; ###########################################################################################
; ##################                                                               ##########
; ##################      This source code is released under the terms of the      ##########
; ##################                  GNU General Public License                   ##########
; ##################                                                               ##########
; ##################                    Author: Felix Schneider                    ##########
; ##################                                                               ##########
; ###########################################################################################
Graphics 800, 600, 32, 2
AppTitle "Assembler Simulator by Felix Schneider"
file = 0
While Not file
	Print "Welche Datei soll geffnet werden?"
	Verzeichnis = ReadDir(".")
	Repeat
		Datei$=NextFile(Verzeichnis)
		If Right(Datei, 4) = ".asm" Then
			Print Datei	
		End If
	Until Datei=""
	CloseDir(Verzeichnis)
	Datei=Input$()
	File=ReadFile(Datei)
	If Not file Then 
		Print "Diese Datei existiert nicht."
	End If
Wend



linecount = 0
sprungmarkencount=0
While Not Eof(File)
	Zeile$ = ReadLine(File)
	If Left(zeile, 2) = "J_" Then sprungmarkencount= sprungmarkencount+1
	zeile = Replace(zeile, " ", "")
	zeile = Replace(zeile, "	", "")
	kommentar=Instr(zeile, ";")
	If kommentar <> 0 Then
		zeile = Left(zeile, (kommentar-1))
	End If 
	If zeile <> "" Then linecount = linecount + 1
Wend
CloseFile(File)


File=ReadFile(Datei)
Dim Zeilen$(linecount)
Dim Sprungmarken$(sprungmarkencount, 2)



stopflag = 0
linecount=0
sprungmarkencount=0
While Not Eof(File)
	sprungflag=0
	Zeile$ = ReadLine(File)
	If Left(Zeile, 2)="J_" Then
		leerzeichen = Instr(zeile, " ")
		leerzeichen2 = Instr(zeile, "	")
		If leerzeichen = 0 Then leerzeichen = 1000
		If leerzeichen2 = 0 Then leerzeichen2 = 1000
		If leerzeichen>leerzeichen2 Then leerzeichen=leerzeichen2
		Sprungmarken(sprungmarkencount, 1)=Left(Zeile, leerzeichen-1)
		Sprungmarken(sprungmarkencount, 2)=linecount
		zeile=Right(Zeile, Len(Zeile)-leerzeichen)
		sprungmarkencount= sprungmarkencount +1

	End If
	zeile = Replace(zeile, " ", "")
	zeile = Replace(zeile, "	", "")
	kommentar=Instr(zeile, ";")
	If kommentar <> 0 Then
		zeile = Left(zeile, (kommentar-1))
	End If 

	If zeile <> "" Then
		Zeilen(linecount)=zeile
		linecount=linecount+1
	End If
Wend
CloseFile(File)

Dim register(32)
register(0)=0




Repeat
	anweisung$ = Input$("Bitte Befehl eingeben. h=hilfe  ..:")
	Select anweisung$
		Case "h"
			Print "q = quit"
			Print "r = register anzeigen"
			Print "s = save"
			Print "run = durchfhren"
			Print "res = reset"
					
		Case "r"
			strNull="0"
			For i = 0 To 15 Step 1 
				If i=10 Then strNull=""
				Print "register " + i + ": "+register(i)+"  register "+ (i+16)+": "+register(i+16)
			Next	
		Case "s"
			Speicherdatei$=Left(Datei, Len(datei)-4)+"_result.txt"
			file=WriteFile(Speicherdatei)
			If file = 0 Then
				Print "Error!"
			Else
				strNull="0"
				For i = 0 To 15 
					If i=10 Then strNull=""
					WriteLine file, "register " + i + ": "+register(i)+"  register "+ (i+16)+": "+register(i+16)
				Next
				CloseFile(file)
				Print "Speichern erfolgreich!"
			End If
		Case "run"
		
For i = 0 To linecount
	Select Left(zeilen(i), 3)
		Case "ADD"
			usestring$=Right(zeilen(i), Len(zeilen(i))-3)
			If Left(usestring$, 2)=".I" Then
				usestring$=Right(usestring$, Len(usestring$)-2)
				destreg=Int(Mid(usestring$, 2, Instr(usestring$,",")-2))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg=Int(Mid(usestring$, 2, Instr(usestring$, ",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				imm=Int(usestring)
				If destreg<>0 Then
					register(destreg)=register(sreg)+imm
				End If
				Print i+": Addiere "+imm+" zu Register "+sreg+" und speichere das in Register "+destreg+"."
			Else
				destreg=Int(Mid(usestring$, 2, Instr(usestring$,",")-2))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg1=Int(Mid(usestring$, 2, Instr(usestring$, ",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg2=Right(usestring, Len(usestring)-1)
				If destreg<>0 Then
					register(destreg)=register(sreg1)+register(sreg2)
				End If
				Print i+": Addiere Register "+sreg2+" zu Register "+sreg1+" und speichere das in Register "+destreg+"."				
			End If
			
			
		Case "SUB"
			usestring$=Right(zeilen(i), Len(zeilen(i))-3)
			If Left(usestring$, 2)=".I" Then
				usestring$=Right(usestring$, Len(usestring$)-2)
				destreg=Int(Mid(usestring$, 2, Instr(usestring$,",")-2))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg=Int(Mid(usestring$, 2, Instr(usestring$, ",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				imm=Int(usestring)
				If destreg<>0 Then
					register(destreg)=register(sreg)-imm
				End If
				Print i+": Subtrahiere "+imm+" von Register "+sreg+" und speichere das in Register "+destreg+"."
			Else
				destreg=Int(Mid(usestring$, 2, Instr(usestring$,",")-2))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg1=Int(Mid(usestring$, 2, Instr(usestring$, ",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg2=Right(usestring, Len(usestring)-1)
				If destreg<>0 Then
					register(destreg)=register(sreg1)-register(sreg2)
				End If
				Print i+": Subtrahiere Register "+sreg2+" von Register "+sreg1+" und speichere das in Register "+destreg+"."	
			End If
			
			
		Case "AND"			usestring$=Right(zeilen(i), Len(zeilen(i))-3)
			If Left(usestring$, 2)=".I" Then
				usestring$=Right(usestring$, Len(usestring$)-2)
				destreg=Int(Mid(usestring$, 2, Instr(usestring$,",")-2))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg=Int(Mid(usestring$, 2, Instr(usestring$, ",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				imm=Int(usestring)
				If destreg<>0 Then
					register(destreg)=register(sreg) And imm
				End If
				Print i+": Wende 'And' auf "+imm+" und Register "+sreg+" an und speichere das in Register "+destreg+"."
			Else
				destreg=Int(Mid(usestring$, 2, Instr(usestring$,",")-2))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg1=Int(Mid(usestring$, 2, Instr(usestring$, ",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg2=Right(usestring, Len(usestring)-1)
				If destreg<>0 Then
					register(destreg)=register(sreg1) And register(sreg2)
				End If
				Print i+": Wende 'And' auf Register "+sreg2+" und Register "+sreg1+" an und speichere das in Register"+destreg+"."
			End If
			
			
		Case "ORr"		; OR has just 2 letters, therefor the "r" from the first register is needed
			usestring$=Right(zeilen(i), Len(zeilen(i))-2) ; Just 2 is subtracted from the length

			If Left(usestring$, 2)=".I" Then
				usestring$=Right(usestring$, Len(usestring$)-2)
				destreg=Int(Mid(usestring$, 2, Instr(usestring$,",")-2))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg=Int(Mid(usestring$, 2, Instr(usestring$, ",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				imm=Int(usestring)
				If destreg<>0 Then
					register(destreg)=register(sreg) Or imm
				End If
				Print i+": Wende 'Or' auf "+imm+" und Register "+sreg+" an und speichere das in Register "+destreg+"."
			Else
				destreg=Int(Mid(usestring$, 2, Instr(usestring$,",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg1=Int(Mid(usestring$, 2, Instr(usestring$, ",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg2=Right(usestring, Len(usestring)-1)
				If destreg<>0 Then
					register(destreg)=register(sreg1) Or register(sreg2)
				End If
				Print i+": Wende 'Or' auf Register "+sreg2+" und Register "+sreg1+" an und speichere das in Register "+destreg+"."

			End If
			
			
		Case "SLL"
			usestring$=Right(zeilen(i), Len(zeilen(i))-3)

			If Left(usestring$, 2)=".I" Then
				usestring$=Right(usestring$, Len(usestring$)-2)
				destreg=Int(Mid(usestring$, 2, Instr(usestring$,",")-2))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg=Int(Mid(usestring$, 2, Instr(usestring$, ",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				imm=Int(usestring)
				If destreg<>0 Then
					register(destreg)=register(sreg) Shl imm
				End If
				Print i+": Verschiebe Register "+sreg+" um "+imm+" Stellen nach links und speichere das in Register" +destreg+"."
			Else
				destreg=Int(Mid(usestring$, 2, Instr(usestring$,",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg1=Int(Mid(usestring$, 2, Instr(usestring$, ",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg2=Right(usestring, Len(usestring)-1)
				If destreg<>0 Then
					register(destreg)=register(sreg1) Shl register(sreg2)
				End If
				Print i+": Verschiebe Register "+sreg1+" um Register"+sreg2+" Stellen nach links und speichere das in Register" +destreg+"."
			End If
			
		
		Case "SRL"
			usestring$=Right(zeilen(i), Len(zeilen(i))-3)

			If Left(usestring$, 2)=".I" Then
				usestring$=Right(usestring$, Len(usestring$)-2)
				destreg=Int(Mid(usestring$, 2, Instr(usestring$,",")-2))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg=Int(Mid(usestring$, 2, Instr(usestring$, ",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				imm=Int(usestring)
				If destreg<>0 Then
					register(destreg)=register(sreg) Shr imm
				End If
				Print i+": Verschiebe Register "+sreg+" um "+imm+" Stellen nach rechts und speichere das in Register " +destreg+"."

			Else
				destreg=Int(Mid(usestring$, 2, Instr(usestring$,",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg1=Int(Mid(usestring$, 2, Instr(usestring$, ",")-1))
				
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				sreg2=Right(usestring, Len(usestring)-1)
				If destreg<>0 Then
					register(destreg)=register(sreg1) Shr register(sreg2)
				End If
				Print i+": Verschiebe Register "+sreg1+" um Register"+sreg2+" Stellen nach rechts und speichere das in Register " +destreg+"."

			End If	
			
				
		Case "NOP"
				; Destroy_Earthlings()
				Print i+": Fhre 'No Operation' aus"
				
				
		Case "SLT"
			usestring$=Right(zeilen(i), Len(zeilen(i))-3)
			destreg=Int(Mid(usestring$, 2, Instr(usestring$,",")-1))
			
			usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
			sreg1=Int(Mid(usestring$, 2, Instr(usestring$, ",")-1))
			
			usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
			sreg2=Right(usestring, Len(usestring)-1)
			Print i+": Fhre (Register "+ sreg1+" < Register "+sreg2+") aus und speichere das Ergebnis in Register "+destreg+"."
			register(destreg)=register(sreg1)<register(sreg2)
		
		Default
			usestring$=zeilen(i)
			If Left(usestring, 1) = "J" Then
				usestring=Right(usestring, Len(usestring)-1)
				If Left(usestring, 1) <> "_" Then
					For j = 0 To sprungmarkencount
						If usestring=sprungmarken(j, 1) Then 
							Print i+": Springe zu Sprungmarke "+sprungmarken(j,1) +" in Zeile "+ sprungmarken(j,2)
							i = Int(sprungmarken(j, 2))-1
							j = sprungmarkencount
						End If
					Next	
				End If
			End If	
			If Left(usestring, 4)="BEQZ" Then
				usestring=Right(usestring, Len(usestring)-5)
				sreg=Int(Left(usestring$, Instr(usestring$, ",")-1))
				usestring$=Right(usestring$, Len(usestring$)-Instr(usestring$, ","))
				If register(sreg)=0 Then
					For j = 0 To sprungmarkencount
						If usestring=sprungmarken(j, 1) Then 
							Print i+": Springe zu Sprungmarke "+sprungmarken(j,1) +" in Zeile "+ sprungmarken(j,2)
							i = Int(sprungmarken(j, 2))-1
							j = sprungmarkencount
						End If
					Next
				End If				
			End If
		End Select

Next	

		Case "res"
			For i = 0 To 31
				register(i)=0
			Next
			Print "Reset erfolgreich"
		
		Default
			Print "Befehl nicht gefunden"
	End Select	
Until anweisung="q"



EndGraphics
End